/****************************************************************************
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  As a special exception, you may use this file as part of a free software
 *  library without restriction.  Specifically, if other files instantiate
 *  templates or use macros or inline functions from this file, or you compile
 *  this file and link it with other files to produce an executable, this
 *  file does not by itself cause the resulting executable to be covered by
 *  the GNU General Public License.  This exception does not however
 *  invalidate any other reasons why the executable file might be covered by
 *  the GNU General Public License.
 *
 ****************************************************************************
 */

 /***************************************************************************
 * File per la presa dei tempi.
 *
 * authors Daniele Buono <d.buono@di.unipi.it>
 *
 ****************************************************************************
 */

#ifndef IAPERF_H_
#include <stdio.h>
#include "cycle.h"

//The IAperf Macros:
#define PERFINITMHZ(clkspd) ticks clocks; \
                        double clockspeed = (unsigned long long)clkspd * 1000000;
#define PERFREPORT fprintf(stderr,"time elapsed = %f sec\n", ((double)clocks)/clockspeed);
#define PERFREPORT2 fprintf(stderr,"cycles elapsed = %li \n", (unsigned long int) clocks );
#define PERFSTART clocks = getticks();
#define PERFSTOP  clocks = getticks() - clocks;
#define IAPERF_H_
#endif /* IAPERF_H_ */